#!/usr/bin/perl

$usage = "Usage: $0 percent db\n\n";

(@ARGV == 2) && (int ($ARGV[0]) || ($ARGV[0] > 0 && $ARGV[0] < 1)) || die $usage;

$percent=$ARGV[0];
$db=$ARGV[1];

$seed=79;
$upper=100 / $percent;
$print=0;
$extracted=0;
$total=0;

srand ($seed);
print STDERR "random extraction from $db ($percent %)\n";
open(DB,$db) || die "cannot open $db:$!";

while (<DB>) {
    if ( /^>/ ) {
	$total++;
	$n = int (rand($upper));
	if ($n < 1) {
	    $extracted++;
	    $print=1;
	} else {
	    $print=0;
	}
    }
    print if ($print);
}

close DB;

$percent_extracted=($extracted/$total) * 100;
print STDERR "$extracted entrie(s) extracted out of $total ($percent_extracted)\n";
